/*
 * utils.c
 * Copyright (C) 2008 wantora
 * MIT License
 */

#include <shlwapi.h>
#include <stdio.h>
#include <time.h>
#include <tchar.h>
#include "utils.h"

#define NAME_SIZE  256

LPTSTR getID() {
	static TCHAR pipeName[NAME_SIZE];
	_stprintf(pipeName, TEXT("%ld_%ld"), GetCurrentProcessId(), time(NULL));
	
	return pipeName;
}

LPTSTR getPipeName(LPCTSTR name) {
	static TCHAR pipeName[NAME_SIZE];
	_stprintf(pipeName, TEXT("\\\\.\\pipe\\sudo_%s"), name);
	
	return pipeName;
}

LPTSTR getEnvPipeName(LPCTSTR name) {
	static TCHAR pipeName[NAME_SIZE];
	_stprintf(pipeName, TEXT("\\\\.\\pipe\\sudo_env_%s"), name);
	
	return pipeName;
}

LPTSTR getCEventName(LPCTSTR name) {
	static TCHAR eventName[NAME_SIZE];
	_stprintf(eventName, TEXT("sudo_exit_%s"), name);
	
	return eventName;
}

LPTSTR shiftArgs(LPTSTR path, int n) {
	LPTSTR result = path;
	
	int i;
	for (i = 0; i < n; i++) {
		result = PathGetArgs(result);
	}
	
	return result;
}
